<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { computed, inject, onMounted, ref, toRef } from 'vue';
import { validMail } from '@/lib/utils';

const props = defineProps<{
    savedMail?: string,
    readOnly?: boolean,
    label?: boolean
}>();
const savedMail = toRef(props, 'savedMail');
const emits = defineEmits(['mail', 'domain', 'error', 'username']);

const mailDomains = [];
const validUsername = ref(true);
const mail = ref('');
const configuration = inject<any>('configuration');
const mailDomain = ref(configuration.mail.preselectedDomain);
const mailDomainsLocal = configuration.mail.mailDomains.split(',');


const mailLocal = ref(computed({
    get: () => mail.value,
    set: (value) => {
        mail.value = value;
        emits('mail', value);
    }
}));

const mailDomainLocal = ref(computed({
    get: () => mailDomain.value,
    set: (value) => {
        mailDomain.value = value;
        emits('domain', value);
    }
}));

const checkMail = () => {
    validUsername.value = validMail(mail.value)
    emits('error', validUsername.value);
};

onMounted(() => {
    if (savedMail.value !== null && savedMail.value !== undefined && savedMail.value.length > 0) {
        mail.value = savedMail.value.split('@')[0];
        mailDomain.value = '@' + savedMail.value.split('@')[1];
    }
    emits('domain', mailDomain.value);
});

</script>
<template>
    <div class="mb-2">
        <div class="mt-2 w-full" v-if="mailDomainsLocal.length === 1">
            <div class="flex flex-row w-full border-gray-300 border h-8 rounded-md bg-white focus-within:border-accent1-default"
                :class="[{ 'text-red-700 border-red-700 bg-red-500/10 focus-within:border-red-600': validUsername == false }]">
                <div class="w-fit px-2"><i class="ri-mail-line ri-1x leading-8 align-middle"></i></div>
                <input class="px-2 grow h-8 bg-transparent focus-visible:outline-0"
                    :class="[{ 'text-red-700': validUsername == false }]" type="text" name="mail" v-model="mailLocal"
                    :placeholder="$t('placeholder.mail')" @input="checkMail()" required
                    style="padding-right:120px!important;text-overflow: ellipsis;"
                    :readonly="readOnly ? readOnly : false">
                <span class="w-32 bg-gray-300 text-black rounded-r-md leading-8 align-middle px-2.5 items-center">{{
                    mailDomainsLocal[0] }}</span>
            </div>
        </div>
        <div class="mt-2 w-full px-0.5" v-else>
            <label v-if="label">{{ $t('placeholder.mail') }}</label>
            <div class="flex flex-row outline outline-1 outline-gray-300 rounded-md h-8"
                :class="{ 'focus-within:outline-accent1-default bg-white': !readOnly, 'focus-within:outline-gray-300 focus:outline-gray-300 focus-visible:outline-gray-300 pointer-events-none bg-gray-100/50 text-gray-400': readOnly, 'text-red-700 border-red-700 bg-red-500/10 focus-within:border-red-600': validUsername == false }">
                <span class="w-fit px-2"><i
                        class="ri-mail-line leading-8 items-center align-middle justify-center inline-flex ri-1x"></i></span>
                <input
                    class="px-2 focus-visible:outline-0 grow h-8 text-ellipsis pr-2.5 border-none bg-transparent peer read-only:text-gray-400"
                    type="text" name="mail" v-model="mailLocal" :placeholder="$t('placeholder.mail')"
                    @input="checkMail()" required :readonly="readOnly ? readOnly : false" autocomplete="off">
                <span
                    class="bg-gray-400 text-white rounded-r-md leading-8 items-center justify-center px-2.5 align-middle"
                    v-if="readOnly">{{ mailDomainLocal }}</span>
                <div class="w-fit" v-if="!readOnly">
                    <select class="w-full border-l px-2 h-full rounded-md focus-visible:outline-0 text-black"
                        name="domain" v-model="mailDomainLocal">
                        <option :key="index" v-for="domain, index in mailDomainsLocal" :value="domain"
                            :disabled="readOnly && domain !== mailDomainLocal"
                            :selected="readOnly && domain == mailDomainLocal">{{
                                domain }}</option>
                    </select>
                </div>
            </div>
        </div>
        <span class="text-red-700" v-if="!validUsername">{{ $t('contentPage.errorName') }}</span>
    </div>
</template>